load('04_output/result_model_Bayesian.RData')
ms <- rstan::extract(fit)

library(ggplot2)
library(GGally)
library(hexbin)

d <- data.frame(b = as.numeric(ms$b) , c = as.numeric(ms$c) , σ = as.numeric(ms$sigma) )
N_col <- ncol(d)
ggp <- ggpairs(d, diag='blank', lower='blank',switch='both') + v1_ggmatrix_theme() + theme(legend.position = "none", 
        panel.grid.major = element_blank(), 
        axis.ticks = element_blank(), 
        panel.border = element_rect(linetype = "solid", colour = "black", fill = NA),strip.text=element_text(size=12))
label_list <- list(b='b', c='c', σ='σ')

for(i in 1 : N_col) {
	x <- d[ ,i]
	bw <- ( max(x) - min(x) ) / 10
	p <- ggplot(data.frame(x), aes(x))
	p <- p + theme_bw(base_size = 14)
	p <- p + theme(axis.text.x = element_text(angle = 60 , vjust = 1 , hjust = 1))
	p <- p + geom_histogram(binwidth = bw/1.5 , fill = 'white' , color = 'grey5' )
	p <- p + geom_line(eval(bquote(aes(y=..count..*.(bw/1.5)))) , stat = 'density' )
	p <- p + geom_label(data=data.frame(x=Inf, y=Inf, label=label_list[[colnames(d)[i]]]), aes(x=x, y=y, label=label), hjust=1, vjust=1)
	ggp <- putPlot(ggp, p, i, i)
}
for(j in 1:(N_col-1)) {
	for(i in (j+1):N_col) 
	{
		x <- d[ ,j]
		y <- d[ ,i]
		p <- ggplot(data.frame(x , y) , aes( x = x , y = y ) )
		p <- p + theme_bw(base_size=14)
		p <- p + theme(axis.text.x=element_text(angle=60, vjust=1, hjust=1))
		p <- p + geom_hex()
		p <- p + scale_fill_gradientn(colours=gray.colors(7, start=0.1, end=0.9))
		ggp <- putPlot(ggp, p, i, j)
	}
}

cairo_pdf(file = '04_output/Fig.1.pdf' , w = 5 , h = 4 )
print(ggp , left = 0.3 , bottom = 0.3, file = NULL)
dev.off()

mean(ms$b);round((sd(ms$b)/mean(ms$b))*100,2)
round(mean(ms$c),2);round((sd(ms$c)/mean(ms$c))*100,2)
round(mean(ms$sigma),2);round((sd(ms$sigma)/mean(ms$sigma))*100,2)