load('04_output/result_model_Bayesian.RData')
ms <- rstan::extract(fit)

library("ggplot2")
theme_set(theme_classic( ))


#Inactivation model
Temp <- c(65)
for(Z in 1 : length( Temp ) )
{
	all_data <- read.csv(file='02_input/Combase_data_set.csv')
	data_one_Temp <- subset( all_data , TE == Temp[Z] )   
	time_interval <- seq( 0 , max( data_one_Temp$TIME ) * 10  , (max( data_one_Temp$TIME  ) * 10 ) / 300 )
	N_time_interval <- length( time_interval )
	N_mcmc <- length( ms$lp__ )
	y_conf_mcmc <- as.data.frame(matrix( nrow = N_mcmc, ncol = N_time_interval) )
	y_predict_mcmc <- as.data.frame(matrix( nrow = N_mcmc, ncol = N_time_interval) )
	for (i in 1:N_time_interval) 
	{
		y_conf_mcmc[ ,i] <- 6.57 - ( ms$b * exp( ms$c * Temp[Z] ) ) * time_interval[i]
  		y_predict_mcmc[ ,i] <- 6.57 - rlnorm( n = N_mcmc , mean = log(ms$b * exp( ms$c * Temp[Z] )) , sd = ms$sigma) * time_interval[i]
	}
	data.frame.quantile.mcmc <- function(x, y_mcmc, probs=c(2.5, 25, 50, 75, 97.5)/100) {
	qua <- apply(y_mcmc, 2, quantile, probs=probs)
	d <- data.frame(X=x, t(qua))
	colnames(d) <- c('X', paste0('p', probs*100))
	return(d)
	}
	d_est_conf <- data.frame.quantile.mcmc( x = time_interval , y_mcmc = y_conf_mcmc )
	d_est_pred <- data.frame.quantile.mcmc( x = time_interval , y_mcmc = y_predict_mcmc )
	all_parameter <- data.frame(B=ms$b,C=ms$c,Sigma=ms$sigma,Lp=ms$lp__)
	MAP <- subset(all_parameter,all_parameter$Lp==max(all_parameter$Lp))
	MAXT_N0 <- -MAP$B*exp(MAP$C*Temp[Z])*max( data_one_Temp$TIME )+6.57
	Xlim_s <- 6.57/(MAP$B*exp(MAP$C*Temp[Z]))
	Xlim <- max( data_one_Temp$TIME )
	if(MAXT_N0 < 0)
	{
		MAXT_N0 <- 0
		Xlim <- Xlim_s
	}
	MAP_x <- c(0,Xlim_s)
	MAP_y <- c(6.57,0)
	MAP_line <- data.frame(time = MAP_x, Num =MAP_y)
	#confidence band and predictive band
	p <- ggplot()
	p <- p + geom_line(data = d_est_conf, aes(x=X, y=p2.5),linetype="dashed")
	p <- p + geom_line(data = d_est_conf, aes(x=X, y=p97.5),linetype="dashed")
	p <- p + geom_line(data = d_est_pred, aes(x=X, y=p2.5),linetype="dotted")
	p <- p + geom_line(data = d_est_pred, aes(x=X, y=p97.5),linetype="dotted")
	p <- p + geom_line(data = MAP_line, aes(x=time, Num))
	p <- p + xlab("Time [h]") +ylab(expression( paste( Log[10],N[t]) ))
	p <- p + theme(axis.text=element_text(size=9,color='black'),title =element_text(size=9))
	p <- p + xlim(0,1.5) + ylim(0,8) 
	p <- p + annotate("text",x=Inf,y=Inf,label="(a)",hjust=1,vjust=1.5)
}


#Total reduction time
p1 <- ggplot()
p1 <- p1 + xlab(expression( paste( Log[10],N[t]) )) +ylab("Density")
p1 <- p1 + annotate("text",x=Inf,y=Inf,label="(b)",hjust=1,vjust=1.5)
p1 <- p1 + theme(axis.text.x=element_text(size=9,color='black'),axis.text.y=element_text(size=9,color='black'))
p1 <- p1 + theme(title =element_text(size=9))
p1 <- p1 + xlim(-5,7)
I <- c( 11 , 21 , 31 )
type=c("solid","dashed","dotted")
for( i in 1:3 )
{
	df <- data.frame(value = y_predict_mcmc[,I[i]] )
	p1 <- p1 + geom_line(data=df, aes(x=value),stat='density',colour="black",linetype=paste(type[i]))

}

T_seq <- seq( 55 , 80 , 1 / 10 )
Total_reduction_time <- matrix( 0 , length(ms$lp__) , length(T_seq) )
for( i in 1:length(T_seq))
{
	Total_reduction_time[,i] <- 6.57 /  rlnorm( length(ms$sigma) , log( ms$b * exp( ms$c * T_seq[i] ) ) , ms$sigma)
}


i <- ( 65 - 54.9 ) / 0.1
df <- data.frame( value = Total_reduction_time[ ,i] )
p2 <- ggplot( df , aes( x = value ) )
p2 <- p2 + geom_line( stat = 'density' , colour = "black" )
p2 <- p2 + xlab( "Time [h]" ) + ylab( "Density" ) + xlim(0 , 1.5)
p2 <- p2 + theme( axis.text = element_text( size = 9 , color = 'black' ) , title = element_text( size = 9 ) )
p2 <- p2 + annotate( "text" , x = Inf , y = Inf , label = "(c)" , hjust = 1 , vjust = 1.5 )

ggsave(file='04_output/Fig.3.pdf', plot=grid.arrange(p, p1, p2, nrow = 3),  w=2.8, h=6)


round(quantile(y_predict_mcmc[,11],c(0.05,0.5,0.95)),2)
round(quantile(y_predict_mcmc[,21],c(0.05,0.5,0.95)),2)
round(quantile(y_predict_mcmc[,31],c(0.05,0.5,0.95)),2)

round(quantile(Total_reduction_time[ ,i],c(0.05,0.5,0.95)),2)
