#Bayesian model
load('04_output/result_model_Bayesian.RData')
ms <- rstan::extract(fit)

library("ggplot2")
theme_set(theme_classic( ))

Temp <- c( 72 )
Z<-1
	all_data <- read.csv(file='02_input/Combase_data_set.csv')
	data_one_Temp <- subset( all_data , TE == Temp[Z] )   
	time_interval <- seq( 0 , max( data_one_Temp$TIME ) , max( data_one_Temp$TIME ) / 100 )
	N_time_interval <- length( time_interval )
	N_mcmc <- length( ms$lp__ )
	y_conf_mcmc <- as.data.frame( matrix( nrow = N_mcmc , ncol = N_time_interval ) )
	y_predict_mcmc <- as.data.frame( matrix( nrow = N_mcmc , ncol = N_time_interval ) )
	for ( i in 1 : N_time_interval ) 
	{
		y_conf_mcmc[ ,i] <- 6.57 - ( ms$b * exp( ms$c * Temp[Z] ) ) * time_interval[i]
		y_predict_mcmc[ ,i] <- 6.57 - rlnorm( n = N_mcmc , mean = log(ms$b * exp( ms$c * Temp[Z] )) , sd = ms$sigma)* time_interval[i]
	}
	data.frame.quantile.mcmc <- function(x, y_mcmc, probs=c(2.5, 25, 50, 75, 97.5)/100) {
	qua <- apply(y_mcmc, 2, quantile, probs=probs)
	d <- data.frame(X=x, t(qua))
	colnames(d) <- c('X', paste0('p', probs*100))
	return(d)
	}
	d_est_conf <- data.frame.quantile.mcmc( x = time_interval , y_mcmc = y_conf_mcmc )
	d_est_pred <- data.frame.quantile.mcmc( x = time_interval , y_mcmc = y_predict_mcmc )
		
	all_parameter <- data.frame(B=ms$b,C=ms$c,Sigma=ms$sigma,Lp=ms$lp__)
	MAP <- subset(all_parameter,all_parameter$Lp==max(all_parameter$Lp))
	MAXT_N0 <- -MAP$B*exp(MAP$C*Temp[Z])*max( data_one_Temp$TIME )+6.57
	Xlim_s <- 6.57/(MAP$B*exp(MAP$C*Temp[Z]))
	Xlim <- max( data_one_Temp$TIME )
	if(MAXT_N0 < 0)
	{
		MAXT_N0 <- 0
		Xlim <- Xlim_s
	}
	MAP_x <- c(0,Xlim)
	MAP_y <- c(6.57,MAXT_N0)
	MAP_line <- data.frame(time = MAP_x, Num =MAP_y)
	p <- ggplot()
	p <- p + geom_line(data = d_est_conf , aes(x = time_interval , y = p2.5 ) , linetype = "dashed" )
	p <- p + geom_line(data = d_est_conf , aes(x = time_interval , y = p97.5 ) , linetype = "dashed" )
	p <- p + geom_line(data = d_est_pred , aes(x = time_interval , y = p2.5 ) , linetype = "dotted" )
	p <- p + geom_line(data = d_est_pred , aes(x = time_interval , y = p97.5 ) , linetype = "dotted" )
	p <- p + geom_line(data = MAP_line,aes(x=time,Num))
	p <- p + geom_point(data = data_one_Temp , aes(x = TIME , y = N_T ) , shape = 16 )
	p <- p + theme( axis.text = element_text( size = 9 , color = 'black' ) , title = element_text( size = 9 ) )



#2step Bayesian model
load('04_output/result_model_2step_Bayesian.RData')
ms <- rstan::extract(fit)

Temp <- c( 72 )
Z<-1
	all_data <- read.csv(file='02_input/Combase_data_set.csv')
	data_one_Temp <- subset( all_data , TE == Temp[Z] )   
	time_interval <- seq( 0 , max( data_one_Temp$TIME ) , max( data_one_Temp$TIME ) / 100 )
	N_time_interval <- length( time_interval )
	N_mcmc <- length( ms$lp__ )
	y_conf_mcmc <- as.data.frame( matrix( nrow = N_mcmc , ncol = N_time_interval ) )
	y_predict_mcmc <- as.data.frame( matrix( nrow = N_mcmc , ncol = N_time_interval ) )
	for ( i in 1 : N_time_interval ) 
	{
		y_conf_mcmc[ ,i] <- 6.57 - ( ms$b * exp( ms$c * Temp[Z] ) ) * time_interval[i]
		y_predict_mcmc[ ,i] <- 6.57 - rlnorm( n = N_mcmc , mean = log(ms$b * exp( ms$c * Temp[Z] )) , sd = ms$sigma)* time_interval[i]
	}
	data.frame.quantile.mcmc <- function(x, y_mcmc, probs=c(2.5, 25, 50, 75, 97.5)/100) {
	qua <- apply(y_mcmc, 2, quantile, probs=probs)
	d <- data.frame(X=x, t(qua))
	colnames(d) <- c('X', paste0('p', probs*100))
	return(d)
	}
	d_est_conf <- data.frame.quantile.mcmc( x = time_interval , y_mcmc = y_conf_mcmc )
	d_est_pred <- data.frame.quantile.mcmc( x = time_interval , y_mcmc = y_predict_mcmc )
	all_parameter <- data.frame(B=ms$b,C=ms$c,Sigma=ms$sigma,Lp=ms$lp__)
	MAP <- subset(all_parameter,all_parameter$Lp==max(all_parameter$Lp))
	MAXT_N0 <- -MAP$B*exp(MAP$C*Temp[Z])*max( data_one_Temp$TIME )+6.57
	Xlim_s <- 6.57/(MAP$B*exp(MAP$C*Temp[Z]))
	Xlim <- max( data_one_Temp$TIME )
	if(MAXT_N0 < 0)
	{
		MAXT_N0 <- 0
		Xlim <- Xlim_s
	}
	MAP_x <- c(0,Xlim)
	MAP_y <- c(6.57,MAXT_N0)
	MAP_line <- data.frame(time = MAP_x, Num =MAP_y)
	p <- p + geom_line(data = d_est_conf , aes(x = time_interval , y = p2.5 ) , linetype = "dashed" , color = 'red')
	p <- p + geom_line(data = d_est_conf , aes(x = time_interval , y = p97.5 ) , linetype = "dashed" , color = 'red')
	p <- p + geom_line(data = d_est_pred , aes(x = time_interval , y = p2.5 ) , linetype = "dotted" , color = 'red')
	p <- p + geom_line(data = d_est_pred , aes(x = time_interval , y = p97.5 ) , linetype = "dotted" , color = 'red')
	p <- p + geom_line(data = MAP_line,aes(x=time,Num), color = 'red')
	p <- p + geom_point(data = data_one_Temp , aes(x = TIME , y = N_T ) , shape = 16 )
	p <- p + xlim( 0 , max( data_one_Temp$TIME ) ) + ylim( 0 , 8 ) 
	p <- p + xlab("Time [h]") + ylab(expression( paste( Log[10],N[t]) ))
	p <- p + theme( axis.text = element_text( size = 9 , color = ) , title = element_text( size = 9 ) )
	p <- p + annotate("text",x=Inf,y=Inf,label="(a)",hjust=1,vjust=1.5)