#Bayesian model
load('04_output/result_model_Bayesian.RData')
ms <- rstan::extract(fit)

library("ggplot2")
theme_set(theme_classic( ))

Temp <-c(55,80)
N_mcmc <- rep( 0 , length( ms$lp__ ) )
T_seq <- seq( min(Temp) , max(Temp) , 1 / 10 )
Uncertainty_m <- matrix( 0 , length(N_mcmc) , length(T_seq) )
Uncertainty_k <- matrix( 0 , length(N_mcmc) , length(T_seq) )
for( i in 1:length(T_seq))
{
	Uncertainty_m[ ,i] <- ms$b*exp(ms$c*T_seq[i])
}
for( i in 1:length(T_seq) )
{
	for(j in 1:length(N_mcmc))
	{
		Uncertainty_k[ j,i] <- rlnorm(1,log(Uncertainty_m[ j,i]),ms$sigma[j])
	}
}
p2 <- ggplot()
p2 <- p2 + xlab(expression( paste(Log , "k(T)") )) +ylab("Density")
p2 <- p2 + theme( axis.text = element_text( size = 9 , color = 'black' ) , title = element_text( size = 9) )
type<- c("solid","dashed","dotted")
I <- c( 1,101,201 )
for( z in 1:3 )
{
    i <- I[z]
    Temperature <- T_seq[i]
    df <- data.frame(value = log( Uncertainty_k[ ,i] ) )
    p2 <- p2 + geom_line(data=df, aes(x=value),stat='density',colour="black",linetype=paste(type[z]))
}


#2step Bayesian model
load('04_output/result_model_2step_Bayesian.RData')
ms <- rstan::extract(fit)

Temp <-c(55,80)
N_mcmc <- rep( 0 , length( ms$lp__ ) )
T_seq <- seq( min(Temp) , max(Temp) , 1 / 10 )
Uncertainty_m <- matrix( 0 , length(N_mcmc) , length(T_seq) )
Uncertainty_k <- matrix( 0 , length(N_mcmc) , length(T_seq) )
for( i in 1:length(T_seq))
{
	Uncertainty_m[ ,i] <- ms$b*exp(ms$c*T_seq[i])
}
for( i in 1:length(T_seq) )
{
	for(j in 1:length(N_mcmc))
	{
		Uncertainty_k[ j,i] <- rlnorm(1,log(Uncertainty_m[ j,i]),ms$sigma[j])
	}
}
I <- c( 1,101,201 )
for( z in 1:3 )
{
    i <- I[z]
    Temperature <- T_seq[i]
    df <- data.frame(value = log( Uncertainty_k[ ,i] ) )
    p2 <- p2 + geom_line(data=df, aes(x=value),stat='density',colour="red",linetype=paste(type[z]))
}
p2 <- p2 + annotate("text",x=Inf,y=Inf,label="(b)",hjust=1,vjust=1.5)+ ylim( 0 , 1.5 )