rm(list=ls())
library(rstan)

d <- read.csv(file='02_input/Combase_data_set.csv')
Rem_T <- 72 
d <- d[ d$TE != paste(Rem_T), ]
d_k <- d[ d$TIME != 0, ]
Nt <- 10 ^ d_k[ ,2]
N0 <- 10 ^ 6.57
time <- d_k[ ,1]
#k(T) estimated from each observed data
d_k[ ,2] <- ( 1 / time ) * log10( N0 / Nt )
#data set for Bayesian model
data <- list( N = nrow(d_k) , TIME = d_k$TIME , N_T = d_k$N_T , TE = d_k$TE )

#MCMC_fitting	
fit <- stan( file = '03_model/model_Bayesian.stan' , data = data , seed = 1234 , iter = 5000 , chain = 4 , thin=1)
save.image( file = '04_output/result_model_Bayesian.RData' )
load('04_output/result_model_Bayesian.RData')
#MCMC_output
ms <- rstan::extract(fit)
